import AppHeader from "@/components/AppHeader";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import { InputForm } from "@/components/inputForm";
import Styles from "@/constants/Styles";
import { apiEditTask, apiGetTaskOne } from "@/lib/api";
import { setUpdateTask } from "@/lib/taskUpdate";
import { useAuthSession } from "@/providers/AuthProvider";
import { useTheme } from "@/providers/ThemeProvider";
import { router, Stack, useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { SafeAreaView, ScrollView, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

export default function TaskDivisionEdit() {
   const { colors } = useTheme();
   const { id, detail } = useLocalSearchParams<{ id: string; detail: string }>();
   const { token, decryptToken } = useAuthSession();
   const [judul, setJudul] = useState("");
   const [error, setError] = useState(false);
   const [disable, setDisable] = useState(false);
   const dispatch = useDispatch();
   const update = useSelector((state: any) => state.taskUpdate);
   const [loading, setLoading] = useState(false)

   async function handleLoad() {
      try {
         const hasil = await decryptToken(String(token?.current));
         const response = await apiGetTaskOne({
            user: hasil,
            cat: "data",
            id: detail,
         });
         setJudul(response.data.title);
      } catch (error) {
         console.error(error);
      }
   }

   useEffect(() => {
      handleLoad();
   }, []);

   function onValidation(val: string) {
      setJudul(val);
      if (val == "" || val == "null") {
         setError(true);
      } else {
         setError(false);
      }
   }

   function checkAll() {
      if (judul == "" || judul == "null" || error) {
         setDisable(true);
      } else {
         setDisable(false);
      }
   }

   useEffect(() => {
      checkAll();
   }, [judul, error]);

   async function handleUpdate() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current));
         const response = await apiEditTask(
            {
               title: judul,
               user: hasil,
            },
            detail
         );
         if (response.success) {
            dispatch(setUpdateTask({ ...update, data: !update.data }));
            Toast.show({ type: 'small', text1: 'Berhasil mengubah data', })
            router.back();
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error : any ) {
         console.error(error);
         const message = error?.response?.data?.message || "Gagal mengubah data"

         Toast.show({ type: 'small', text1: message })
      } finally {
         setLoading(false)
      }
   }

   return (
      <SafeAreaView style={{ flex: 1, backgroundColor: colors.background }}>
         <Stack.Screen
            options={{
               // headerLeft: () => (
               //    <ButtonBackHeader
               //       onPress={() => {
               //          router.back();
               //       }}
               //    />
               // ),
               headerTitle: "Edit Judul",
               headerTitleAlign: "center",
               // headerRight: () => (
               //    <ButtonSaveHeader
               //       category="update"
               //       disable={disable || loading}
               //       onPress={() => { handleUpdate() }}
               //    />
               // ),
               header: () => (
                  <AppHeader title="Tambah Kegiatan"
                     showBack={true}
                     onPressLeft={() => router.back()}
                     right={
                        <ButtonSaveHeader
                           category="update"
                           disable={disable || loading}
                           onPress={() => { handleUpdate() }}
                        />
                     }
                  />
               )
            }}
         />
         <ScrollView>
            <View style={[Styles.p15, Styles.mb100]}>
               <InputForm
                  label="Judul Kegiatan"
                  type="default"
                  placeholder="Judul Kegiatan"
                  required
                  bg={colors.card}
                  value={judul}
                  onChange={(val) => { onValidation(val) }}
                  error={error}
                  errorText="Judul Kegiatan harus diisi"
               />
            </View>
         </ScrollView>
      </SafeAreaView>
   );
}
